source('~/kent/research/programms/EM/hyper_geom/mainEM_3d_size_shape.r')
source('~/kent/research/programms/EM/hyper_geom/EM_size_2d.r')
load("~/kent/research/programms/EM/Rats_size_shape.RData")
##open the file 2d_regression_data.. and start from 
load("~/kent/research/programms/EM/Rats_size_shape.RData")

gen_model_data=function(outreg,To=log(T),n=100,reflection=1,helmert=1)
  #generate some shape data for the fitted model whose output is out as argument here
  #if reflection is 1 we can reflect the 3d-data  
{ 
  d=dim(outreg$rot)[1:2]
  deg=dim(outreg$A)[2]/(d[2]-1)-1
  A=outreg$A
  TM=rep(1,length(To))
  Ik=diag(rep(1,d[2]-1));
  Im=diag(rep(1,d[1]));
  Imref=Im
  Imref[d[1],d[1]]=reflection
  for (i in 1:deg)
    TM<-cbind(TM,To^i)
  SimData=array(0,c(d,length(To),n))
  Csqrt=diag(rep(1,d[2]))
  
  if(sum(dim(outreg$C))>0)
  {
    a=svd(outreg$C)
    Csqrt[2:d[2],2:d[2]]=a$u%*%diag(a$d^0.5)%*%t(a$v)/outreg$sigma# this is becasue outreg$sigma is added as default later 
  }
  
  for(j in 1:n)
    for(i in 1:length(To))
    {
      E=array(rnorm(prod(d),sd=outreg$sigma),d)
      if(helmert==1)
      SimData[,,i,j]=QRshpvar((Imref%*%(A%*%kronecker(TM[i,],Ik))+E[,2:d[2]]%*%Csqrt[2:d[2],2:d[2]])%*%(defh(d[2]-1))) 
      if(helmert!=1)
        SimData[,,i,j]=QRshpvar(cbind(array(0,c(d[1],1)),Imref%*%(A%*%kronecker(TM[i,],Ik))+E[,2:d[2]]%*%Csqrt[2:d[2],2:d[2]]))
     }
  SimData
}


TT=seq(log(T)[1],log(T)[8],length=8)
set.seed(123)
DD1=gen_model_data(out1,To=TT,n=500)

DD2=gen_model_data(out2,To=TT,n=500)

DD3=gen_model_data(out3,To=TT,n=500)

DD1g=gen_model_data(out1g,To=TT,n=500)

DD2g=gen_model_data(out2g,To=TT,n=500)

DD3g=gen_model_data(out3g,To=TT,n=500)

dd=DD3
ddg=DD3g
plotspec=1
if(plotspec==1)
{
  par(mfrow=c(1,2))
  
  plot(t(out1$rot[,,1,1]),xlim=range(out1$rot[1,,,]),ylim=range(out1$rot[2,,,])*1.6-300,xlab="",ylab="",axes=FALSE)
  library(jpeg)
  #img=readJPEG("/Users/alfredkume/kent/research/talks/Helsinki/images/book1.jpg")
  #img=readJPEG("~/kent/research/talks/Helsinki/images/book1.jpg")
  #####rasterImage(img,-200+40,-400+40,1100+50,620-50,angle=5)
  #polygon(t(out1$rot[,land,1,10]))
  polygon(t(QRshpvar(Data[,land,1,1])))
  
  #d=dim(DD)
  # for (i in 1:d[3])
  #   for (j in 1:d[4])
  #   {
  #     points(t(DD[,,i,j]),col="black",cex=.3,pch=i)
  #     lines(t(DD[,j,i,]),col="grey",lty=2)
  #     #points(t(out1$f[,,i,j]),col="red",cex=.3)
  #     #points(t(out2$f[,,i,j]),col="green",cex=.3)
  #     #polygon(t(QRshpvar(Data[,land,i,j])))
  #   }
  
  library(scales)
  d=dim(dd)
  for (i in 1:d[2])
    for (j in 1:d[4])
    {
      #lines(t(DD2[,j,i,]),col="grey",lty=2)
      # lines(t(DD2[,j,i,]),col=alpha("grey",0.1),lty=2)
      points(t(dd[,i,,j]),col=alpha("grey",0.1), pch=".")
      lines(t(dd[,i,,j]),col=alpha("grey",0.1), pch=".")
    }  
  d=dim(out1$rot)
  
  # for (i in 1:d[3])
  #   for (j in 1:d[2])
  #   {
  #     lines(t(out1$rot[,j,i,]),col=alpha("blue",0.1),lty=1)
  # #    lines(t(out1$f[,j,,1]),col="red")
  #     lines(t(out2$f[,j,,1]),col=alpha("green",0.1))   
  #     #lines(t(out3$f[,j,,1]),col="black") 
  #     #readline()
  #   }
  
  ####Changing the way lines are connecting along time## July 19 Nttingham 
  for (i in 1:d[4])
    for (j in 1:d[2])
    {
      lines(t(out1$f[,j,,i]),col=alpha("blue",0.1),lty=1)
      #    lines(t(out1$f[,j,,1]),col="red")
      lines(t(out2$f[,j,,i]),col=alpha("green",0.1))   
      lines(t(out3$f[,j,,i]),col="black") 
      #readline()
    }
  ###################
  
  
  
  plot(t(out1$rot[,,1,1]),xlim=range(out1$rot[1,,,]),ylim=range(out1$rot[2,,,])*1.6-300,xlab="",ylab="",axes=FALSE)
  library(jpeg)
  #img=readJPEG("/Users/alfredkume/kent/research/talks/Helsinki/images/book1.jpg")
  #img=readJPEG("~/kent/research/talks/Helsinki/images/book1.jpg")
  #####rasterImage(img,-200+40,-400+40,1100+50,620-50,angle=5)
  #polygon(t(out1$rot[,land,1,10]))
  polygon(t(QRshpvar(Data[,land,1,1])))
  d=dim(ddg)
  for (i in 1:d[2])
    for (j in 1:d[4])
    {
      #lines(t(DD2[,j,i,]),col="grey",lty=2)
      # lines(t(DD2[,j,i,]),col=alpha("grey",0.1),lty=2)
      points(t(ddg[,i,,j]),col=alpha("grey",0.1), pch=".")
      lines(t(ddg[,i,,j]),col=alpha("grey",0.1), pch=".")
    }  
  
  d=dim(out1g$f)
  for (i in 1:d[4])
    for (j in 1:d[2])
    {
      lines(t(out1g$f[,j,,i]),col=alpha("blue",0.1),lty=1)
      #    lines(t(out1$f[,j,,1]),col="red")
      lines(t(out2g$f[,j,,i]),col=alpha("green",0.1))   
      lines(t(out3g$f[,j,,i]),col="black") 
      #readline()
    }
  
  
  
}

###################
tt=array(0,c(8,8))
tt[-1,-1]=svd(out1g$C)$u%*%diag(1/sqrt(svd(out1g$C)$d))%*%t(svd(out1g$C)$v)
tt[1,1]=1
tt=pi/2

for (i in 1:d[4])
  for (j in 1:d[2])
  {
    lines(t(out1newg$f[,j,,i]* tt),col=alpha("blue",0.1),lty=1)
    #    lines(t(out1$f[,j,,1]),col="red")
    lines(t(out2newg$f[,j,,i]* tt),col=alpha("green",0.1))   
    lines(t(out3newg$f[,j,,i]* tt),col="black") 
    #readline()
  }
#############
############
for (i in 1:d[4])
  for (j in 1:d[2])
  {
    lines(t(out1g$f[,j,,i]),col=alpha("red",0.1),lty=1)
    #    lines(t(out1$f[,j,,1]),col="red")
    lines(t(out2g$f[,j,,i]),col=alpha("green",0.1))   
    lines(t(out3g$f[,j,,i]),col="black") 
    #  readline()
  }



plot(t(out1$rot[,,1,1]),xlim=range(out1$rot[1,,,]),ylim=range(out1$rot[2,,,])*1.6-300,xlab="",ylab="",axes=FALSE)
library(jpeg)
#img=readJPEG("/Users/alfredkume/kent/research/talks/Helsinki/images/book1.jpg")
#img=readJPEG("~/kent/research/talks/Helsinki/images/book1.jpg")
#############rasterImage(img,-200+40,-400+40,1100+50,620-50,angle=5)
#polygon(t(out1$rot[,land,1,10]))
polygon(t(QRshpvar(Data[,land,1,1])))

d=dim(DD1)
for (i in 1:d[2])
  for (j in 1:d[4])
  {
    #lines(t(DD2[,j,i,]),col="grey",lty=2)
    # lines(t(DD2[,j,i,]),col=alpha("grey",0.1),lty=2)
    points(t(DD1[,i,,j]),col=alpha("grey",0.1), pch=".")
    lines(t(DD1[,i,,j]),col=alpha("grey",0.1), pch=".")
  }  

d=dim(out1$rot)
for (i in 1:d[3])
  for (j in 1:d[4])
  {
    #points(t(out1$rot[,,i,j]),col="black",cex=.3,pch=i)
    points(t(out1$rot[,,i,j]),col=alpha("blue",0.1),cex=.3,pch=".")
    #    points(t(out1$f[,,i,j]),col="red",cex=.3)
    #points(t(out1$f[,,i,j]),col="green",cex=.3)
    points(t(out1$f[,,i,j]),col=alpha("green",0.1),cex=.3,pch=".")
    #polygon(t(QRshpvar(Data[,land,i,j])))
  }

# for (i in 1:d[3])
#   for (j in 1:d[2])
#   {
#     #lines(t(out1$rot[,j,i,]),col="black",lty=2)
#     lines(t(out1$rot[,j,i,]),col=alpha("blue",0.1),lty=1)
#     #    lines(t(out1$f[,j,,1]),col="red")
#     lines(t(out1$f[,j,,1]),col=alpha("green",0.1))   
#     #lines(t(out3$f[,j,,1]),col="black") 
#     #readline()
#   }
# 


####Changing the way lines are connecting along time## July 19 Nttingham and August 2019
for (i in 1:d[4])
  for (j in 1:d[2])
  {
    #lines(t(out1$rot[,j,i,]),col="black",lty=2)
    lines(t(out1$rot[,j,,i]),col=alpha("blue",0.1),lty=1)
    #    lines(t(out1$f[,j,,1]),col="red")
    lines(t(out1$f[,j,,i]),col=alpha("green",0.1))   
    #lines(t(out3$f[,j,,1]),col="black") 
    #readline()
  }

#### TRy the cubic polynomial for isotropic and general covariance #?#21 October '19

#separate plot now

par(mfrow=c(1,2))

plot(t(out1$rot[,,1,1]),xlim=range(out1$rot[1,,,]),ylim=range(out1$rot[2,,,])*1.6-300,xlab="",ylab="",axes=FALSE)
library(jpeg)
#img=readJPEG("/Users/alfredkume/kent/research/talks/Helsinki/images/book1.jpg")
#img=readJPEG("~/kent/research/talks/Helsinki/images/book1.jpg")
#####rasterImage(img,-200+40,-400+40,1100+50,620-50,angle=5)
#polygon(t(out1$rot[,land,1,10]))
polygon(t(QRshpvar(Data[,land,1,1])))

#d=dim(DD)
# for (i in 1:d[3])
#   for (j in 1:d[4])
#   {
#     points(t(DD[,,i,j]),col="black",cex=.3,pch=i)
#     lines(t(DD[,j,i,]),col="grey",lty=2)
#     #points(t(out1$f[,,i,j]),col="red",cex=.3)
#     #points(t(out2$f[,,i,j]),col="green",cex=.3)
#     #polygon(t(QRshpvar(Data[,land,i,j])))
#   }

library(scales)
d=dim(DD3)
for (i in 1:d[2])
  for (j in 1:d[4])
  {
    #lines(t(DD2[,j,i,]),col="grey",lty=2)
    # lines(t(DD2[,j,i,]),col=alpha("grey",0.1),lty=2)
    points(t(DD3[,i,,j]),col=alpha("grey",0.1), pch=".")
    lines(t(DD3[,i,,j]),col=alpha("grey",0.1), pch=".")
  }  

d=dim(out1$rot)
for (i in 1:d[3])
  for (j in 1:d[4])
  {
    points(t(out3$rot[,,i,j]),col=alpha("blue",.1),cex=.3,pch=".")
    #    points(t(out1$f[,,i,j]),col="red",cex=.3)
    points(t(out3$f[,,i,j]),col=alpha("green",0.1),cex=.3,pch=".")
    #polygon(t(QRshpvar(Data[,land,i,j])))
  }

####Changing the way lines are connecting along time## July 19 Nttingham 
for (i in 1:d[4])
  for (j in 1:d[2])
  {
    lines(t(out3$rot[,j,,i]),col=alpha("blue",0.1),lty=1)
    #    lines(t(out1$f[,j,,1]),col="red")
    #lines(t(out2$f[,j,,i]),col=alpha("green",0.1))   
    lines(t(out3$f[,j,,i]),col="black") 
    #readline()
  }
###################


plot(t(out1$rot[,,1,1]),xlim=range(out1$rot[1,,,]),ylim=range(out1$rot[2,,,])*1.6-300,xlab="",ylab="",axes=FALSE)
library(jpeg)
#img=readJPEG("/Users/alfredkume/kent/research/talks/Helsinki/images/book1.jpg")
#img=readJPEG("~/kent/research/talks/Helsinki/images/book1.jpg")
#####rasterImage(img,-200+40,-400+40,1100+50,620-50,angle=5)
#polygon(t(out1$rot[,land,1,10]))
polygon(t(QRshpvar(Data[,land,1,1])))

#d=dim(DD)
# for (i in 1:d[3])
#   for (j in 1:d[4])
#   {
#     points(t(DD[,,i,j]),col="black",cex=.3,pch=i)
#     lines(t(DD[,j,i,]),col="grey",lty=2)
#     #points(t(out1$f[,,i,j]),col="red",cex=.3)
#     #points(t(out2$f[,,i,j]),col="green",cex=.3)
#     #polygon(t(QRshpvar(Data[,land,i,j])))
#   }

library(scales)
d=dim(DD3g)
for (i in 1:d[2])
  for (j in 1:d[4])
  {
    #lines(t(DD2[,j,i,]),col="grey",lty=2)
    # lines(t(DD2[,j,i,]),col=alpha("grey",0.1),lty=2)
    points(t(DD3g[,i,,j]),col=alpha("grey",0.1), pch=".")
    lines(t(DD3g[,i,,j]),col=alpha("grey",0.1), pch=".")
  }  

d=dim(out1$rot)
for (i in 1:d[3])
  for (j in 1:d[4])
  {
    points(t(out3$rot[,,i,j]),col=alpha("blue",.1),cex=.3,pch=".")
    #    points(t(out1$f[,,i,j]),col="red",cex=.3)
    points(t(out3$f[,,i,j]),col=alpha("green",0.1),cex=.3,pch=".")
    #polygon(t(QRshpvar(Data[,land,i,j])))
  }

####Changing the way lines are connecting along time## July 19 Nttingham 
for (i in 1:d[4])
  for (j in 1:d[2])
  {
    lines(t(out3g$rot[,j,,i]),col=alpha("blue",0.1),lty=1)
    #    lines(t(out1$f[,j,,1]),col="red")
    #lines(t(out2$f[,j,,i]),col=alpha("green",0.1))   
    lines(t(out3g$f[,j,,i]),col="black") 
    #readline()
  }
###################







############################
#####3d now###########################
###############################################
setwd("~/kent/research/programms/EM/hyper_geom/")
setwd("~/PC/research/programms/EM/hyper_geom")
library(shapes)
library(rgl)
#load(file = "HumanMovement_noether.RData") use the Bootstral workspace as the sigma's are bigger
load("~/kent/research/programms/EM/hyper_geom/Boostrap_noether_3d.RData")

#TT=seq(log(T)[1],log(T)[8],length=50)
TT=1:100
DD1=gen_model_data(reg22,To=TT,n=50,reflection=-1)

DD2=gen_model_data(reg32,To=TT,n=50,reflection=-1)


#Use this command for gererating gif files and then convert -coalesce *.gif to *.png to latex them
####some different plots for JASAs version##
shapes3d(aperm(reg2$f[,,,1],c(2,1,3)))
planes3d(a=0,b=0,c=1,d=c(0,0,0),color = "lightgrey")
for (i in 1:14)
  #shapes3d(aperm(reg2$r[,,,i],c(2,1,3)),rglopen=FALSE)
  spheres3d(reg2$r[,,,i])




####plots for JASA###
shapes3d(aperm(reg22$f[,,,1],c(2,1,3)),col="green")
planes3d(a=0,b=0,c=1,d=c(0,0,0),color = "lightgrey")

for (i in 1:14)
  spheres3d(reg22$r[,,,i],col="red",radius=2,rglopen=FALSE)
#shapes3d(aperm(reg22$r[,,,i],c(2,1,3)),rglopen=FALSE)
#spheres3d(aperm(reg22$r[,,,i],c(2,1,3)),col="red",radius=150,rglopen=FALSE)

for (i in 1:50)
  spheres3d(DD1[,,,i],col=alpha("grey",0.1),cex=.3,pch=".",rglopen=FALSE)

#for (i in 1:14)
#spheres3d(reg22$r[,,,i],col="red",cex=.7,pch=".",rglopen=FALSE)



# spheres3d(reg3$f[,,,1]+c(100,0,0),radius = 15,col=2)
# spheres3d(reg1$f[,,,1]+c(200,0,0),radius = 15,col=3)
# planes3d(a=0,b=0,c=1,d=c(0,0,0),color = "lightgrey")
# ########
# shapes3d(aperm(reg32$f[,,,1],c(2,1,3)),col="green")
# for (i in 1:14)
#   spheres3d(reg3$r[,,,i],col=alpha("blue",0.1),cex=.3,pch=".",rglopen=FALSE)
# 
# for (i in 1:50)
#   spheres3d(DD1[,,,i],col=alpha("grey",0.1),cex=.3,pch=".",rglopen=FALSE)


######
shapes3d(aperm(reg32$f[,,,1],c(2,1,3)),col="green")
planes3d(a=0,b=0,c=1,d=c(0,0,0),color = "lightgrey")

for (i in 1:14)
  spheres3d(reg32$r[,,,i],col="red",radius=2,rglopen=FALSE)

for (i in 1:50)
  spheres3d(DD2[,,,i],col=alpha("grey",0.1),cex=.3,pch=".")

#########



#rgl.postscript("plots_2_3pol.pdf","pdf")
#reg3=EM.poly.fit.cov.3d(D,deg=3,kk=meth); 
#reg3=EM.poly.fit.cov.3d(D,A=reg3$A,sigmainit=reg3$s,deg=3,kk=meth); 

# shapes3d(aperm(reg3$f[,,,1],c(2,1,3)))
# planes3d(a=0,b=0,c=1,d=c(0,0,0),color = "lightgrey")

#####################################################

################bootstrap 2d now#############
####################################################
run=0
if(run==1)
{
  num_sim=1000
  llog=1:num_sim
  
  Sim_summary2d=array(0,c(dim(out2$A)[1],dim(out2$A)[2]+1,num_sim))
  
  TT=log(T)
  set.seed(1234)
  for (i in 1:num_sim)
  {
    DD1=gen_model_data(out2,To=TT,n=dim(out2$rot)[4],reflection=-1) 
    reg2_sim=EM.poly.fit.cov.2d(DD1,deg=2,A=out2$A,sigmainit=out2$s,niter=1000); 
    Sim_summary2d[,-1,i]=reg2_sim$A
    Sim_summary2d[1,1,i]=reg2_sim$sigma
    Sim_summary2d[2,1,i]=reg2_sim$loglik
    save.image(file = "Boostrap_2d.RData")
  }
}

load("~/kent/research/programms/EM/EM_size_shape/Boostrap_2d.RData")
i=num_sim
sum(Sim_summary2d[2,1,1:i]>out2$loglik)/i

hist(Sim_summary2d[2,1,1:i],axes = FALSE,xlab = "",ylab = "",main = "")
arrows(out2$loglik,-140,out2$loglik,0,length=0.1,col = "red")


load("~/kent/research/programms/EM/hyper_geom/Boostrap_noether_3d.RData")
sum(Sim_summary[3,1,1:i]>reg32$loglik)/i

hist(Sim_summary[3,1,1:i],xlab = "",ylab = "",main = "",axes = FALSE)
arrows(reg32$loglik,-140,reg32$loglik,0,length=0.1,col = "red")
##############################################
####Some more simulation study here####
######################################################
##I will need to simulate a changing mean departing from the 2d plane and moving 
#it away from it away from the singularity region.
##########################################################
num=40
rr=seq(1,45,length=num)
MM=array(0,c(3,num))
MM[,1]=c(60,50,1)
#cd=c(2,1,10)
for (i in 1:num)
  MM[,i]=c(60,50,rr[i])


MM_MLE1=array(0,c(3,4*2,num))
MM_MLE2=MM_MLE1

MM_MLEnew=array(0,c(3,4*2,num,4))

SSdd=c(0.1,.2,.3,.4)
SSdd=SSdd[1:4]

NN=c(200,500,1000,2000,2500)
m=3
kk=4
RR=40
#Res.tot1=array(0,c(6,6,5,3,8,RR))
#Res.tot[,,,,,]=Res.tot1
#RR number of rounds for which the average quantities will be taken

#ii changes the mean mean 
## jj changes the sdev choices
## nn sample size
##rr nr landmarks
## elements are Res[ii,jj,nn,rr,1:8,round] see end line###

set.seed(123)
cc=NULL
for (i in 1:num)
  for (jj in 1:4)
  {
    cd=MM[1:m,i]
    k=4
    sdev<-SSdd[jj]
    n=NN[5]
    # cd=1:2
    # m=2;k=5
    # sdev=.2
    # n=10
    k=4
    M<-cbind(diag(cd),array(0,c(m,k-m)))
    M=M/centroid.size(t(M))
    #I construct the mean M for simulations
    
    
    #n is teh sample size for the simulations
    
    D<-array(rnorm(n*k*m,sd=sdev),c(m,k,n))+rep(M,n)
    
    for (index in 1:n)
    {
      #s<-svd(D[,,i])
      D[,,index]<-QRshpvar(D[,,index])
      #D[,,i]<-qrdecom(D[,,i])$T/norm(D[,,i])
      #shapes
      # D[,,i]<-svdecom(D[,,i])$T
    }
    #D<-array(rnorm(n*k*m,sd=sdev),c(m,k,n))+rep(M,n)
    a=EMfunc.3d.size.shape(D,land="",out="conf", itermax =300, tol = 1e-6,spa =1)
    a$sdev
    #riemdist(preshapetoicon(t(M)),(t(a$mco)))
    
    riemdist(t(M),(t(a$mco)))
    
    #a=EMfunc.2d.size.shape(D,preshape=FALSE,land="",out="conf")
    
    #riemdist(t(M),t(a$mco))*centroid.size(t(M))*centroid.size(t(a$mco))
    #a$sdev
    
    # a.diag.cov=EMfunc.2d.size.shape(xp[,1:3,],preshape=FALSE,Cov="Diag",land="",out="conf")
    
    # a.gen.cov=EMfunc.2d.size.shape(xp[,1:3,],preshape=FALSE,Cov="Gen",land="",out="conf")
    
    gp<-procGPA(aperm(D,c(2,1,3)),scale=FALSE)
    
    MM_MLE1[,,i]=cbind(a$mconf,t(gp$mshape))
    MM_MLEnew[,,i,jj]=cbind(a$mconf,t(gp$mshape))
    
    # ans$mshape
    SS=mean(apply(D[,,],c(3),norm)^2)
    
    
    SS=mean(apply(aperm(D,c(2,1,3)),c(3),centroid.size)^2)
    
    
    cc=c(cc,a$sdev,sqrt((SS-norm(gp$msh)^2)/(k-1)/m))
    cc=c(cc,riemdist(t(M),t(a$mco))*centroid.size(t(M))*centroid.size(t(a$mco)),riemdist(gp$msh,t(M))*centroid.size(t(M))*centroid.size(gp$msh) )
    
    # Res.tot[ii,jj,nn,rr,1,round]=riemdist(gp$msh,t(M))*centroid.size(t(M))*centroid.size(gp$msh)
    # #preshape distances of proc mean with true mean
    # Res.tot[ii,jj,nn,rr,2,round]=riemdist(gp$msh,t(M))
    # #riemanian shape distanceof of proc mean with true mean
    # Res.tot[ii,jj,nn,rr,3,round]=sqrt((SS-norm(gp$msh)^2)/(k-1)/m)
    # #sdev after prococrustes matchings
    # Res.tot[ii,jj,nn,rr,4,round]=riemdist(t(M),t(a$mco))
    # #riemanian shape distanceof of mle mean with true mean
    # Res.tot[ii,jj,nn,rr,5,round]=riemdist(t(M),t(a$mco))*centroid.size(t(M))*centroid.size(t(a$mco))
    # #preshape distances of mle mean with true mean
    # Res.tot[ii,jj,nn,rr,6,round]=a$sdev;
    # Res.tot[ii,jj,nn,rr,,round]
    # save.image()
    # cat(ii,jj,nn,rr, "sigma=",a$sdev,SSdd[jj],"round=",round)
    
  }
#save.image(file = "Many_changing means.RData")
#save.image(file = "Many_changing means_spa1.RData")
#save.image(file = "Many_changing means_spa1_1.RData")
#load("~/kent/research/programms/EM/hyper_geom/Many_changing means.RData")

#load("~/kent/research/programms/EM/hyper_geom/Many_changing means_spa1.RData")

#load("~/kent/research/programms/EM/hyper_geom/Many_changing means_spa1_1.RData")

for (i in 1:num)
  for (jj in 1:4)
  {
    sdev=SSdd[jj]
    cc0=NULL
    for (rr in 1:40)
      cc0=c(cc0,cc [1:4+4*(jj-1)+16*(rr-1)])
    
    Mle=aperm(QRshpvar(MM_MLEnew[,1:4,i,jj]),c(2,1))
    Mproc=aperm(QRshpvar(MM_MLEnew[,1:4+4,i,jj]),c(2,1))
    cd=MM[1:m,i]
    M<-cbind(diag(cd),array(0,c(m,k-m)))
    M=QRshpvar(M/centroid.size(t(M)))
    MTr=t(M)
    
    
    stnd=0
    if(stnd==1)
    {
      Mle=Mle/Mle[2,1]
      MTr=MTr/MTr[2,1]
      Mproc=Mproc/Mproc[2,1]
    }
    
    spheres3d(MTr,radius=.01,col="green",rglopen=TRUE)
    #spheres3d(Mle,col="red",radius=.01*sdev/cc0[1+4*(i-1)],rglopen=FALSE)
    spheres3d(Mproc,col="blue",radius=.01*sdev/cc0[2+4*(i-1)],rglopen=FALSE)
    #readline()
    planes3d(a=0,b=0,c=1,d=c(0,0,0),color = "lightgrey")
    Sys.sleep(5)
    #readline()
  }

#############################################################################################################
###############################################################################################################
################################
#############################################
###Bootstrap in 2d example now###########
###############################################

num_sim=1000
llog=1:num_sim


Sim_summary=array(0,c(dim(out3g$A),num_sim))
TT=log(T)
outsim=out3g
#outsim$C=outsim$C*.7
set.seed(123)
for (i in 1:num_sim)
{
  #out3g$C=out3g$C*.7
  DD3g=gen_model_data(outsim,To=log(T),n=18,reflection = -1)
  reg3_2d_sim=EM.poly.fit.cov.2d(DD3g,A=outsim$A,Cinit=outsim$C,To=log(T),deg=3,niter=10,cov="Gen")
  
  Sim_summary[,,i]=reg3_2d_sim$A
  #Sim_summary[2,1,i]=reg3_2d_sim$sigma
  Sim_summary[2,1,i]=reg3_2d_sim$loglik
  save.image(file = "Boostrap_2d.RData")
}  
load("~/kent/research/programms/EM/hyper_geom/Boostrap_2d.RData");i
sum(Sim_summary[2,1,1:i]>out3g$loglik)

####################Some tests#######################################
Csqrt=diag(rep(1,d[2]))
Csqrt[1,1]=1
x=invsqrtmat(out3g$C)$sqrt
Csqrt[2:d[2],2:d[2]]=x

R=(defh(d[2]-1))%*%Csqrt
R%*%t(R)-x%*%t(x)
a=invsqrtmat(R%*%t(R))$sqrt

DD3g=gen_model_data(out3g,To=log(T),n=1800)

xbar=apply(DD3g[,,1,], 1:2,mean)
S=(defh(d[2]-1))%*%t(DD3g[,,1,1]-xbar)%*%(DD3g[,,1,1]-xbar)%*%t(defh(d[2]-1))*0
for (i in 1:dim(DD3g)[4])
  S=S+(defh(d[2]-1))%*%t(DD3g[,,1,i]-xbar)%*%(DD3g[,,1,i]-xbar)%*%t(defh(d[2]-1))

S=S/dim(DD3g)[4]
(S-out3g$C)/out3g$C
#####################################################################################